

/**
*
*   Vitamin C  Version 3.0
*   Copyright (c) 1985, 86, 87
*   Creative Programming Consultants
*   P.O. Box 12097
*   Carrollton, Texas  75011-2097
*   (214)245-6090
*   ALL RIGHTS RESERVED
*
*   name            vcstdio.h  --  Vitamin C standard header file
*
*   synopsis
*
*   description
*
*
*
**/


#define VCNOMEM         1    /* Out of memory.                            */
#define VCBADGTBL       2    /* Pointer to get table is NULL or not       */
                             /* pointing at a valid get table node struct */
#define VCNOGTBL        3    /* No get table nodes defined                */
#define VCNOSYM         4    /* Symbol not found                          */
#define VCSYMREQ        5    /* Symbol required. (NULL not allowed)       */
#define VCNOAUTH        6    /* User not authorized for operation         */
#define VCBADGET        7    /* Pointer to get node is NULL or is not     */
                             /* pointing to a valid get node structure    */
#define VCNOGETS        8    /* No "gets" have been issued on this get    */
                             /* table.                                    */
#define VCBADMNU        9    /* Pointer to menu is NULL or not pointing   */
                             /* to a valid menu structure                 */
#define VCBADMITM      10    /* Pointer to menu item is NULL or not       */
                             /* pointing to a valid menu item structure   */
#define VCBADMSTL      11    /* Pointer to menu style is NULL or not      */
                             /* pointing to a valid menu style structure  */
#define VCONEMSTL      12    /* There is only one style in the style list */
                             /* and it may not be deleted                 */
#define VCNOMSTL       13    /* No matching menu style was found          */
#define VCCANNOT       14    /* Unable to do desired operation            */
#define VCWISOPN       15    /* Window is already open                    */
#define VCBADED        16    /* Pointer to editor node is NULL or not     */
                             /* to a valid editor node structure          */
#define VCEDBUF        17    /* editor buffer is full                     */
#define VCFNTOPN       18    /* error opening disk file                   */
#define VCSYMEXTS      19    /* symbol already exists                     */
#define VCBADCORD      20    /* invalid coordinates                       */
#define VCBADSET       21    /* Pointer to selection set is NULL or not   */
                             /* to a valid selection set structure        */
#define VCBADSITM      22    /* Pointer to selection item is NULL or not  */
                             /* to a valid selection item structure       */
#define VCSETEMPT      23    /* selection set is empty                    */



#define VERSION "3.0  Jan. 1, 1987"

/*----------------------------------------------------------------------*/
/*------------------------ENVIRONMENT DEFINITIONS-----------------------*/
/*----------------------------------------------------------------------*/

/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */
/*  This file defines the type of hardware and the compiler that is to  */
/*  be used.  You must #define ONE symbol from the COMPILERS group, and */
/*  ONE symbol from the HARDWARE group below.                           */
/*                                                                      */
/*      COMPILERS                                                       */
/*         LC.................. Lattice v2.x or v3 Compiler             */
/*         MSC................. Microsoft C Compiler v3.x or v4.x       */
/*         CI.................. Computer Innovations                    */
/*         DESMET.............. DeSmet Compiler                         */
/*         AZ.................. Aztec                                   */
/*         MW.................. Mark Williams                           */
/*         DL.................. Datalight                               */
/*                                                                      */
/*      HARDWARE                                                        */
/*         IBM................. IBM PC and Compatibles                  */
/*                                                                      */
/* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *  */
#define  MSC
#define  IBM

/*  REPLACE THE FOLLOWING LINE WITH  #define ???  where ??? is one of the
*   compiler codes listed above.
*/

#define MSC
#define MAXROW 25     /* The number of rows on the screen               */
#define MAXCOL 80     /* The number of columns on the screen            */

/*----------------------------------------------------------------------*/
/*-------------------------Standard I/O Files---------------------------*/
/*----------------------------------------------------------------------*/

#include <stdio.h>
#include <ctype.h>
#define min(a,b)  ((a) < (b) ? (a) : (b))
#define max(a,b)  ((a) > (b) ? (a) : (b))
#define VCF_RB "rb"
#define VCF_RT "rt"
#define VCF_R  "r"
#define VCF_WB "wb"
#define VCF_WT "wt"
#define VCF_W  "w"
typedef unsigned char TEXT,BYTE;



/*----------------------------------------------------------------------*/
/*------------------------KEYBOARD DEFINITIONS--------------------------*/
/*----------------------------------------------------------------------*/

#define FBIT 256
#define FBIT1 512


#define BTAB 15+FBIT
#define ALT_A 30+FBIT
#define ALT_B 48+FBIT
#define ALT_C 46+FBIT
#define ALT_D 32+FBIT
#define ALT_E 18+FBIT
#define ALT_F 33+FBIT
#define ALT_G 34+FBIT
#define ALT_H 35+FBIT
#define ALT_I 23+FBIT
#define ALT_J 36+FBIT
#define ALT_K 37+FBIT
#define ALT_L 38+FBIT
#define ALT_M 50+FBIT
#define ALT_N 49+FBIT
#define ALT_O 24+FBIT
#define ALT_P 25+FBIT
#define ALT_Q 16+FBIT
#define ALT_R 19+FBIT
#define ALT_S 31+FBIT
#define ALT_T 20+FBIT
#define ALT_U 22+FBIT
#define ALT_V 47+FBIT
#define ALT_W 17+FBIT
#define ALT_X 45+FBIT
#define ALT_Y 21+FBIT
#define ALT_Z 44+FBIT
#define ALT_ESC 0xAA+FBIT
#define F1 59+FBIT
#define F2 60+FBIT
#define F3 61+FBIT
#define F4 62+FBIT
#define F5 63+FBIT
#define F6 64+FBIT
#define F7 65+FBIT
#define F8 66+FBIT
#define F9 67+FBIT
#define F10 68+FBIT
#define HOME_KEY 71+FBIT
#define CUR_LEFT 75+FBIT
#define CUR_RIGHT 77+FBIT
#define CUR_UP 72+FBIT
#define CUR_DOWN 80+FBIT
#define END_KEY 79+FBIT
#define PGUP 73+FBIT
#define PGDN 81+FBIT
#define INS_KEY 82+FBIT
#define DEL_KEY 83+FBIT
#define SF1 84+FBIT
#define SF2 85+FBIT
#define SF3 86+FBIT
#define SF4 87+FBIT
#define SF5 88+FBIT
#define SF6 89+FBIT
#define SF7 90+FBIT
#define SF8 91+FBIT
#define SF9 92+FBIT
#define SF10 93+FBIT
#define CSF1 94+FBIT
#define CSF2 95+FBIT
#define CSF3 96+FBIT
#define CSF4 97+FBIT
#define CSF5 98+FBIT
#define CSF6 99+FBIT
#define CSF7 100+FBIT
#define CSF8 101+FBIT
#define CSF9 102+FBIT
#define CSF10 103+FBIT
#define ACF1 104+FBIT
#define ACF2 105+FBIT
#define ACF3 106+FBIT
#define ACF4 107+FBIT
#define ACF5 108+FBIT
#define ACF6 109+FBIT
#define ACF7 110+FBIT
#define ACF8 111+FBIT
#define ACF9 112+FBIT
#define ACF10 113+FBIT
#define CTRL_PS 114+FBIT
#define CTRL_CRIGHT 116+FBIT
#define CTRL_CLEFT 115+FBIT
#define CTRL_END 117+FBIT
#define CTRL_PGDW 118+FBIT
#define CTRL_HOME 119+FBIT
#define CTRL_PGUP 132+FBIT
#define ALT_1 120+FBIT
#define ALT_2 121+FBIT
#define ALT_3 122+FBIT
#define ALT_4 123+FBIT
#define ALT_5 124+FBIT
#define ALT_6 125+FBIT
#define ALT_7 126+FBIT
#define ALT_8 127+FBIT
#define ALT_9 128+FBIT
#define ALT_0 129+FBIT
#define ALT_MS 130+FBIT
#define ALT_EQ 131+FBIT

#define QUIT_INPUT ESC
#define INSERT INS_KEY
#define DEL_RIGHT DEL_KEY
#define DEL_LEFT BKSP
#define FLD_LEFT CUR_UP
#define FLD_RIGHT CUR_DOWN
#define DN_LIST TAB
#define UP_LIST BTAB


#define VCFORMAT 2
#define VCDELLIN 25
#define WORD_LEFT CTRL_CLEFT
#define WORD_RIGHT  CTRL_CRIGHT


/*----------------------------------------------------------------------*/
/*--------------------------Typedef for Variables-----------------------*/
/*----------------------------------------------------------------------*/

typedef int COUNT;
typedef unsigned int UCOUNT;
typedef TEXT *TEXTPTR;
typedef int WORD,VOID,BOOL;
typedef WORD *WORDPTR;
typedef long LONG;
typedef long ULONG;
typedef WORD (*PFI)(),(*VALIDF)();
typedef TEXT (*PFC)();
typedef LONG (*PFL)();

#define NULLFUNC (PFI) 0

/*----------------------------------------------------------------------*/
/*------------------------SPECIAL PROGRAM DEFINES-----------------------*/
/*----------------------------------------------------------------------*/


/*----------------------------------------------------------------------*/

/*----------------------------- MAGIC NUMBERS --------------------------*/
#define GETTBLMAGIC  902
#define GETNODEMAGIC 105
#define FLDNODEMAGIC 791
#define MENUMAGIC    619
#define MENUSTYLEMAGIC 209
#define MENUITEMMAGIC 6809
#define SELITEMMAGIC  4692
#define VCPROKEYMAGIC 32109
#define EDNODEMAGIC 32583

/*----------------------------------------------------------------------*/

#define VCDTBLNAM "VC DEFAULT TABLE"
#define VCSYMNAMSIZ 31

#define AGET 1
#define NAGET 2
#define SAY 3
#define GET 4
#define SET 5
#define TRUE 1
#define FALSE 0
#define ON 1
#define OFF 0
#define TOGGLE 2
#define ESC 0x1b
#define BELL 7
#define BKSP 0x08
#define RET 13
#define LF 10
#define TAB 9
#define TABSIZE 8
#define SPACE 32
#define CLEFT 3        /* Used internally to control cursor             */
#define CRIGHT 4       /* These Do not relate to the keys pressed       */
#define CUP 1          /* or the Commands to control the screen         */
#define CDOWN 2        /*                                               */
#define BKSPC 3        /*                                               */
#define GOOD 0
#define BAD 1
#define SAVESCRN 1
#define CLRSCRN 0
#define CLOSE 1
#define NOCLOSE 0 
#define COMBO 2
#define DOUBLE 0
#define SINGLE 1

/*----------------------------------------------------------------------*/

#define WMAX 51        /* Max Number of Windows plus 1                  */
#define WOFFSET 2      /* Offset for screen Attribute byte              */
#define WCOL MAXCOL    /* Max Number of Columns in Display Count from 1 */
#define WROW MAXROW    /* Max Number of Rows in Display Count from 1    */

/*----------------------Window Control Byte Values----------------------*/

#define WOPEN 1        /* Tell if a Window is open                      */
#define BORDER 2       /* Print Border around the Window                */
#define ACTIVE 4       /* Active means Display on Screen                */
#define CURSOR 8       /* Put a Cursor on the next position to print    */
#define SCROLL 16      /* Scroll the window after last line, last col.  */
#define BD1 0          /* Use Border Number 1                           */
#define BD2 32         /* Use Border Number 2                           */
#define BD3 64         /* Use Border Number 3                           */
#define BD4 96         /* Use Border Number 4 (not defined)             */
#define COOKED 128     /* Convert Control Codes in Windows              */
#define WINSERT 256    /* In or Out of Insert Mode for Window           */
#define WDWRAP 512     /* Word Wrap on-1 or Off-0                       */
#define SCROLLBARS 1024 /* Show scrollbars in virtual windows           */
#define MARGIN 2048    /* Set margins in windows  (experimental)        */
#define NOADJ 4096     /* Do not allow the Program to adj window        */
#define STANDARD 0     /* Open Window by pulling down from top          */
#define CENTER 8192    /* Open Window from the Center out               */
#define TLDN 16384     /* Pull Down from Top Left                       */
#define CUSTOM 24576   /* Custom Open                                   */
#define CUTPASTE 0     /* Ability to cut/paste 1-yes 0-no (experimental)*/


#define NOTOPEN -1     /* Window not Open during wselect(), wclose()    */
#define CUROPEN -1     /* Trying to Open window Already open            */
#define NOROOM -1

/*----------------------Field Control Byte Values----------------------*/
#define FLDBLANK 128
#define NOCONFIRM 256
#define SETONLY 512
#define VCEDLIN 1024
#define STRING 2048
#define INTEGER 4096
#define REAL 8192


#define EDIT 1
#define VIEW 2


#define VC_SEG(fp) (*((unsigned *)&(fp) + 1))
#define VC_OFF(fp) (*((unsigned *)&(fp)))


/*--------------------- MENU DEFINES ---------------------------*/
#define MENUCHECK 175

#define AUTO -1

#define UNAVAILABLE  1
#define SEPARATOR    2
#define STRPARM      4
#define MENU         8
#define RETURN      16
#define BLANKITEM   32
#define HIDE        64
#define ESCAPE     128
#define REFRESH    256
#define CHECKED    512
#define MNUACTIVE 1024      /* DON'T use this as option. INTERNAL USE ONLY */
#define MENUERROR 2048      /* DON'T use this as option. INTERNAL USE ONLY */


#define HORIZONTAL   1
#define VERTICAL     2
#define BORDERLESS   4
#define TITLELEFT    8
#define TITLERIGHT  16
#define TITLECENTER 32

/*--------------------- EDITOR DEFINES ---------------------------*/

#define NLH '\n'          /* Hard Carriage Return */
#define NLS (NLH+128)     /* Soft Carriage Return */

#define PNLH 20           /* Char to display for Hard Newline */
#define PNLS 29           /* Char to display for Soft Newline */

#define SPS (' '+128)     /* Soft space */

#define TABSIZ 4          /* editor converts ^i to this many spaces */



/*--------------------- MISC DEFINES ---------------------------*/

#define DEFAULT -1
#define VCPRNTRHNDL  4

#define MAXHLP 300

#define NLCHAR '~'



/*----------------------------------------------------------------------*/
/*--------------------Contains all structure definitions----------------*/
/*----------------------------------------------------------------------*/


struct VC_PROKEY
   {
   COUNT magic;
   struct VC_PROKEY *next;
   COUNT keycode;
   PFI func;
   TEXT *aux;
   };



struct VC_KEYS
   {
   COUNT fldup;          /* CUR_UP     */
   COUNT flddown;        /* CUR_DOWN   */
   COUNT fldleft;        /* CUR_UP     */
   COUNT fldright;       /* CUR_DOWN   */
   COUNT curright;       /* CUR_RIGHT  */
   COUNT curleft;        /* CUR_LEFT   */
   COUNT curup;          /* CUR_UP     */
   COUNT curdown;        /* CUR_DOWN   */
   COUNT pgdown;         /* PG_DN      */
   COUNT pgup;           /* PG_UP      */
   COUNT menuup;         /* CUR_UP     */
   COUNT menudown;       /* CUR_DOWN   */
   COUNT menuleft;       /* CUR_LEFT   */
   COUNT menuright;      /* CUR_RIGHT  */
   COUNT nxtsel;         /* END_KEY    */
   COUNT prvsel;         /* HOME_KEY   */
   COUNT nxtselpg;       /* CTRL_END   */
   COUNT prvselpg;       /* CTRL_HOME  */
   COUNT bksp;           /* BKSP       */
   COUNT delete;         /* DEL_KEY    */
   COUNT insert;         /* INS_KEY    */
   COUNT done;           /* ^J (^RET)  */
   COUNT abort;          /* ESC        */
   COUNT hkey;           /* F1         */
   COUNT wakey;          /* F2         */
   COUNT decikey;        /* DEL_KEY    */
   };


struct VCSYM
   {
   COUNT decimal;
   COUNT thousep;
   COUNT currency;
   };

struct VCED_KEYS
   {
   COUNT insmode;           
   COUNT justmode;          
   COUNT shosoft;           
   COUNT hibit;             
   COUNT reform;            
   COUNT curup;             
   COUNT curdown;           
   COUNT curleft;           
   COUNT curright;
   COUNT wrdlft;            
   COUNT wrdrt;             
   COUNT dellin;            
   COUNT scrlup;            
   COUNT scrldn;            
   COUNT pageup;            
   COUNT pagedn;            
   COUNT beglin;            
   COUNT endlin;            
   COUNT edexit;
   COUNT begfil;            
   COUNT endfil;            
   COUNT topscrn;           
   COUNT botscrn;           
   COUNT tab;               
   COUNT begmark;           
   COUNT copy;              
   COUNT cut;               
   COUNT paste;             
   COUNT find;
   COUNT replace;
   };

struct VCED_NODE
    {
    struct VCED_NODE *next;
    COUNT magic;
    COUNT firstpass;
    TEXT *buf;
    COUNT bufsiz;                /* 32k max since not unsigned */
    TEXT *bufptr;                /* pointer to cur loc in buf  */
    COUNT bufndx;                /* current index into buf     */
    TEXT *eofptr;
    COUNT eofndx;
    TEXT *pgptr;
    COUNT pgndx;
    COUNT pgrow;
    COUNT row;
    COUNT col;
    COUNT wno;
    struct WINF *wptr;
    COUNT edchmask;
    COUNT insert;
    COUNT justify;
    COUNT shoall;
    COUNT keyhit;
    COUNT result;
    COUNT nondoc;
    TEXT *auxptr;
    COUNT auxrow;
    COUNT auxcol;
    TEXT *scrap;
    COUNT scrapsiz;
    struct VCED_KEYS key;
    FILE *fp;
    };

/*------------------------ SELECTION SET STRUCTURE ---------------------*/

struct SEL_ITEM
   {
   COUNT magic;
   struct SEL_ITEM *next;
   struct SEL_ITEM *prev;
   TEXT *display;
   TEXT *value;
   };

/*---------------------- GETS STRUCTURES -------------------------------*/

struct GET_NODE    /*  This is the structure of the "get table" entries */
    {
    struct GET_NODE *next;
    struct GET_NODE *up;
    struct GET_NODE *down;
    struct GET_NODE *left;
    struct GET_NODE *right;
    COUNT magic;
    COUNT _lin;
    COUNT _col;
    COUNT _length;
    TEXTPTR _field;
    TEXTPTR _picture;
    TEXTPTR _msg;
    TEXTPTR _help;
    PFI _funptr;
    COUNT attrag;       /* active get attribute                         */
    COUNT attrnag;      /* non-active get attribute                     */
    COUNT maxwid;       /* max width to display before field scrolls    */
    COUNT control;      /* Bit-coded options                            */
    struct SEL_ITEM *selset;
    PFI prefunc;
    PFI postfunc;
    TEXT *tmppic;
    TEXT *tmpfld;
    COUNT curattr;
    COUNT fldtyp;
    COUNT dispsiz;
    COUNT wno;
    };


struct GETTBL_NODE
    {
    struct GETTBL_NODE *next;
    struct GET_NODE *head;
    struct GET_NODE *tail;
    struct GET_NODE *curnode;
    struct GET_NODE *startnode;
    TEXT table_name[VCSYMNAMSIZ+1];
    COUNT magic;
    COUNT status;
    COUNT result;
    COUNT wno;
    };



struct wcolr
 {
 COUNT black;
 COUNT blue;
 COUNT green;
 COUNT cyan;
 COUNT red;
 COUNT magenta;
 COUNT brown;
 COUNT white;
 COUNT bold;            /* Added to Color for Bright except Bg          */
 COUNT blink;           /* Added to Color to Blink                      */
 COUNT bg;              /* Must be Multiplied by color                  */
 COUNT dflt;
 };

struct BODR
    {
    COUNT up;           /* Character to Print Up the Screen             */
    COUNT across;       /* Character to Print Across the Screen         */
    COUNT tl;           /* Top Left Character                           */
    COUNT tr;           /* Top Right Character                          */
    COUNT bl;           /* Bottom Left Character                        */
    COUNT br;           /* Bottom Right Character                       */
    COUNT lside;        /* Merge with Left Side Character               */
    COUNT rside;        /* Merge with Right Side Character              */
    COUNT mb;           /* Merge with Bottom Character                  */
    COUNT mt;           /* Merge with Top Character                     */
    COUNT middle;       /* Middle Intersection                          */
    };

/*                      Table for Default Window Colors                 */

struct WTBL
    {
    COUNT bd_t;         /* Default Border Attribute                     */
    COUNT bg_t;         /* Default Background Attribute                 */
    COUNT say_t;        /* Default Say Attribute                        */
    COUNT nget_t;       /* Default Non Active Get Attribute             */
    COUNT get_t;        /* Default Get Attribute                        */
    COUNT tit_t;        /* Default Title Attribute                      */
    };

struct WINF
 {
 COUNT control;         /* Window Control Byte                          */
 COUNT upper_r;         /* Upper Right                                  */
 COUNT upper_c;         /* Upper Left                                   */
 COUNT lower_r;         /* Lower Right                                  */
 COUNT lower_c;         /* Lower Left                                   */
 TEXT  fill_ch;         /* Fill Character for Window                    */
 COUNT border_at;       /* Border Attribute                             */
 COUNT bg_at;           /* Background Attribute                         */
 COUNT say_at;          /* Print in Window Attribute                    */
 COUNT get_at;          /* Read from Window Attribute                   */
 COUNT nget_at;         /* Non Active get Attribute                     */
 COUNT tit_at;          /* Title Attribute                              */
 TEXTPTR title;         /* Pointer to Title for window                  */
 COUNT width;           /* Width of the Actual Window                   */
 COUNT depth;           /* Depth of the Actual Window                   */
 COUNT c_pos;           /* Current Cursor Column                        */
 COUNT r_pos;           /* Current Cursor Row                           */
 COUNT cur_r;           /* Current Row of top Left-Displayed            */
 COUNT cur_c;           /* Current Column to top left-Displayed         */
 TEXTPTR location;      /* Pointer to Location of Window                */
 TEXTPTR replaced;      /* Pointer to Location of Replaced Text         */
 COUNT lmargin;         /* Window Left Margin                           */
 COUNT rmargin;         /* Window Right Margin                          */
 };

/*-------------------------- MENU STRUCTURES ---------------------------*/
struct VCM_STYLE
   {
   struct VCM_STYLE *next;
   COUNT magic;
   TEXT *stylename;
   COUNT mnustyle;
   COUNT width;
   COUNT normattr;
   COUNT barattr;
   COUNT unavattr;
   COUNT bordattr;
   COUNT itmctrl;
   COUNT permlvl;
   };

struct VC_MENU
   {
   struct VC_MENU *next;
   struct VC_MENU *prev;
   struct VC_MENU *calledby;       /* Pointer to menu that called this one */
   COUNT magic;
   TEXT *menuname;
   COUNT style;
   COUNT row;
   COUNT col;
   COUNT width;
   struct VCM_ITEM *itemhead;
   struct VCM_ITEM *itemtail;
   struct VCM_ITEM *curitmptr;
   COUNT curitmnbr;
   COUNT normattr;
   COUNT barattr;
   COUNT unavattr;
   COUNT bordattr;
   TEXT *helpkey;
   COUNT itemcnt;
   COUNT itemwid;
   COUNT knamwid;
   COUNT checks;
   COUNT mnuwid;
   COUNT permlvl;
   struct WINF *wptr;
   COUNT wno;
   COUNT result;
   COUNT funcret;
   COUNT keyhit;
   };


union VCM_PARM
   {
   COUNT *numptr;
   TEXT *chrptr;
   struct VC_MENU *mnuptr;
   };
 
struct VCM_ITEM
   {
   struct VCM_ITEM *next;
   struct VCM_ITEM *prev;
   COUNT magic;
   TEXT *itemname;
   TEXT *keyname;
   COUNT keynum;
   PFI func;
   union VCM_PARM parm;
   COUNT *chkvar;
   TEXT *helpkey;
   TEXT *stat;
   COUNT itemnbr;
   COUNT hcoords;
   COUNT ctrl;
   };




       struct VCREGS   { COUNT ax,bx,cx,dx,si,di,ds,es; };

struct HLP_STR
        {
        TEXT keyword[40];
        LONG filloc;
        };




typedef struct WINF *WPTR;
typedef struct SEL_ITEM VCSELSET;
typedef struct GETTBL_NODE GETTABLE;
typedef struct GET_NODE GETITEM;
typedef struct VCM_STYLE MENUSTYLE;
typedef struct VC_MENU VCMENU;
typedef struct VCM_ITEM MENUITEM;
typedef struct VC_PROKEY VCPROKEY;
typedef struct VCED_NODE VCED;

/*----------------------------------------------------------------------*/
/*----------------------SPECIAL FILES AND VARIABLES---------------------*/
/*----------------------------------------------------------------------*/


extern VCPROKEY *prokeytbl;

extern PFI vckbfunc;

extern struct VCSYM vcsym;

extern struct VCED_KEYS edkeys;

extern struct VC_KEYS vckey;
extern PFI vcehook1;
extern PFI vcehook2;
extern PFI vcehook3;
extern PFI vcehook4;



/*----------------------------------------------------------------------*/

extern COUNT vcerrno;  /* Global error number                           */
extern COUNT vcalocnt; /* running tab of vcalloc()'s vc vcfree()'s      */

extern COUNT cs_row;   /* Current Row                                   */
extern COUNT cs_col;   /* Current Column                                */
extern COUNT hkey;     /* Help key                                      */
extern COUNT xhkey;    /* Exit help key                                 */
extern COUNT wakey;    /* window adjust key defaults to F2              */
                       /* TRUE if in help func so further presses of    */
extern COUNT inhelp;   /* helpkey don't keep calling help again.  FALSE */
extern COUNT inwadj;   /* if not in help function.  All handled in      */
                       /* getone                                        */
extern TEXTPTR hlptxt; /* Pointer to Help Text                          */
extern COUNT fkey;     /* Use only with xgetone()                       */
extern COUNT msgrow;   /* Message Row                                   */
extern COUNT msgcol;   /* Message Column                                */
extern COUNT msgwno;   /* Window number for stat msg                    */

extern COUNT vctimwno; /* Window number for real time clock display     */
extern COUNT vctimrow; /* row coordinate for real time clock display    */
extern COUNT vctimcol; /* col coordinate for real time clock display    */
extern COUNT vctimattr;/* attribute for real time clock display         */

extern COUNT override; /* Override Window logic Yes-1 No-0              */
extern PFI waitfunc;   /* Pointer to Wait function                      */
extern PFI helpfunc;   /* Pointer to Help function                      */
extern PFI debugfunc;  /* Pointer to Debug function                     */
extern COUNT bellstat; /* Bell Off-1 or On-0                            */
extern struct GETTBL_NODE *vcdgt;  /* pointer to the default get table  */
extern COUNT vcdgcw;   /* Default Get Control Word                      */
extern COUNT mexit;    /* Master Exit Key - Usually ESC                 */


/*-------------------------Used in gets---------------------------------*/

extern COUNT userlevel;


/*-------------------Used in Left to Right gets-------------------------*/

extern COUNT insmode;
extern COUNT numget;   /* also used in right to left mode               */



extern COUNT VCCOL;    /* Maximum number of Columns                     */
extern COUNT VCROW;    /* Maximum number of Rows                        */

extern COUNT attrag;   /* ATTRibute for Active Gets                     */
extern COUNT attrnag;  /* ATTRibute for Non-Active Gets                 */
extern COUNT attrsay;  /* ATTRibute for Say's                           */
extern COUNT normattr; /* Normal attribute for system                   */
extern COUNT termattr; /* Current terminal attribute                    */

extern struct wcolr vc;

/*----------------------------------------------------------------------*/

extern COUNT wcurrent;  /* Current Window Open                          */
extern COUNT wno_active;/* Number of Active Windows                     */
extern COUNT wstdctrl;  /* standard control byte for window in wopen()  */
extern COUNT wno_opn;   /* Number of Open Windows                       */
extern COUNT wfreeze;   /* Freeze output to Current Active Window       */
extern COUNT wbgdisplay;/* Check to see if it is ok to print on screen  */
extern COUNT wdisplay[];/* Order in which Windows are Displayed         */
extern COUNT wsrninit;  /* Window screen initialized                    */
extern COUNT WFILE;     /* Translate LF to Ret for Text from Files      */
extern COUNT lastchlf;  /* Last Character was LF in WFILE Mode          */
extern COUNT retlf;     /* Return = return + line feed                  */
extern COUNT cur_switch;/* Move cursor on or off                        */
extern COUNT wtabsize;  /* Size of Tab in COOKED and WFILE Windows      */
extern COUNT wdelay;    /* Delay on window opens                        */
extern COUNT rowcut;    /* Number of Rows in Cut and Paste              */
extern COUNT colcut;    /* Number of Columns in Cut and Paste           */
extern COUNT VCVRAM;    /* Screen location 0xb000 = monchrome           */
extern COUNT VCSPRT;    /* color monitor Video status port, mono=0x3ba  */
extern COUNT VC_VIO;    /* Method to output to screen                   */
extern struct WINF winfo[]; /* Main Window Structure                    */
extern TEXT wscreen[WROW][WCOL*WOFFSET]; /*    Memory Screen            */
extern TEXT wbscreen[WROW][WCOL*WOFFSET];/*    Backup Memory Screen     */


extern COUNT wmaxtab;
extern COUNT wtab[];
extern struct BODR border[];
extern struct WTBL wtable[];

extern struct WTBL wmono[];

extern struct VCM_STYLE vcmstyle;
extern struct VC_MENU *vcmchain;
extern PFI vcmhook1;
extern PFI vcmhook2;
extern PFI vcmhook3;
extern PFI vcmhook4;
extern PFI vcmhook5;

extern PFI vcghook1;
extern PFI vcghook2;
extern PFI vcghook3;

extern struct HLP_STR hlpndx[];
extern FILE *hlpfil;




#define VCSTDIO 1




/*
 * End of file
*/
 
